<template>
  <div class="dashboard-loans-page pt-3 pb-5">
    <h2>New Loan</h2>
    <div class="mt-3">
      <!-- <div class="d-flex justify-content-end">
        <button class="btn btn-primary">
          <soan class="me-2"> +</soan> New loan
        </button>
      </div> -->
      <form @submit.prevent="submitForm">
        <div class="row mt-3">
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 1 - Select loan type</p>
            <div class="mt-3">
              <!--  v-for="(plan, i) in loanPlans" :key="i" -->
              <div v-for="(plan, i) in loanPlans" :key="i" class="mt-3">
                <input
                  type="radio"
                  name="activeLoan"
                  v-model="form.activeLoan"
                  :value="trimText(plan.name)"
                  :id="trimText(plan.name)"
                  class="account-radio d-none"
                  @change="fetchDurations"
                />
                <label :for="trimText(plan.name)" class="w-100">
                  <div class="loan-type-card">
                    <div class="d-flex">
                      <div>
                        <h5 class="m-0 fw-bold text-capitalize">
                          {{ plan.name }}
                        </h5>
                      </div>
                    </div>
                    <div>
                      <div class="d-flex justify-content-between">
                        <p class="w-75 m-0">
                          {{ plan.description }}
                        </p>
                      </div>

                      <div class="text-end float-end"></div>
                    </div>
                  </div>
                </label>
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 2 - Select amount and duration</p>
            <div class="mt-3">
              <div class="card w-100" ref="loanContent">
                <div class="form-group">
                  <p class="fw-bold">How much would you like to invest?</p>
                  <label>Amount </label>
                  <input
                    type="text"
                    class="form-control form-control-lg"
                    v-model="form.amount"
                    v-validate="'required|integer'"
                    name="Amount"
                  />

                  <currency-input
                    v-model="form.amount"
                    v-validate="'required|decimal'"
                    currency="NGN"
                    class="form-control"
                    type="text"
                    name="Amount"
                  />
                  <div v-show="verrors.has('Amount')" class="invalid-feedback">
                    {{ verrors.first('Amount') }}
                  </div>
                </div>
                <div class="form-group mt-4">
                  <p class="fw-bold">For how long do you want to borrow?’</p>
                  <select
                    v-model="form.duration"
                    class="form-select form-select-lg"
                    v-validate="'required'"
                    name="Duration"
                  >
                    <option :value="null">Select Duration</option>
                    <option
                      v-for="(duration, i) in durations"
                      :key="i"
                      :value="duration"
                    >
                      {{ duration }}
                    </option>
                  </select>
                  <div
                    v-show="verrors.has('Duration')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Duration') }}
                  </div>
                </div>
                <div class="mt-5">
                  <!-- <p class="text-primary fw-bold text-center mt-3">
                    Change Fund Source
                  </p> -->
                </div>
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-4">
            <p class="fw-bold">Step 3 - Summary</p>
            <div class="mt-3">
              <div class="card w-100">
                <p class="fw-bold">
                  Here is the summary of what your request looks like
                </p>
                <div class="mt-4 mb-3">
                  <div class="d-flex justify-content-between">
                    <p>Principal Loan</p>
                    <p class="fw-bold">
                      {{ form.amount | formatPrice }}
                    </p>
                  </div>
                  <div class="d-flex justify-content-between">
                    <p>Interest Rate</p>
                    <p class="fw-bold">{{ currentLoan.interestRate }}%</p>
                  </div>
                  <div class="d-flex justify-content-between">
                    <p>Tenure</p>
                    <p class="fw-bold">{{ form.duration }}</p>
                  </div>
                  <div class="d-flex justify-content-between">
                    <p>Estimated total to repay</p>
                    <h4 class="fw-bold text-success">
                      {{ calculateEstimatedPay() | formatPrice }}
                    </h4>
                  </div>
                </div>
                <div class="mt-5">
                  <vs-button :loading="form.active" type="submit" class="w-100">
                    Confirm
                  </vs-button>
                </div>
              </div>
            </div>
          </div>
          <div class="col-sm-12 col-md-6"></div>
        </div>
      </form>
    </div>

    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      class="modal fade"
      id="PaymentSuccessModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Loan Successful</h3>
              <p class="text-muted my-2 px-3">
                Congratulations, you have successfully applied for
                <span class="fw-bold text-dark">
                  {{ currentLoan.name }} Loan.
                </span>
              </p>
              <p class="text-muted my-2 px-3">
                You will be notified once your loan is approved and disbursement
                is made
              </p>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    type="button"
                    style="font-size: 14px"
                    data-bs-dismiss="modal"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'dashboard',
  components: {},
  data: () => ({
    durations: [],
    form: {
      active: false,
      duration: null,
    },
  }),
  async asyncData({ $axios }) {
    const loanPlans = await $axios.$get('/loan/plans?page=1&limit=10')
    const userAccounts = await $axios.$get('/user/accounts')
    // console.log(loanPlans)
    return {
      loanPlans: loanPlans.payload.data,
      userAccounts: userAccounts.payload,
    }
  },
  created() {
    this.form.activeLoan = this.trimText(this.loanPlans[0].name)
    this.form.accountFrom = this.userAccounts[0]
  },
  mounted() {
    this.fetchDurations()
  },
  computed: {
    currentLoan() {
      const that = this
      return this.loanPlans.find(function (inv) {
        return that.trimText(inv.name) === that.form.activeLoan
      })
    },
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    calculateEstimatedPay() {
      return (
        this.form.amount &&
        +this.form.amount * (this.currentLoan.interestRate / 100) +
          +this.form.amount
      )
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const data = {
            principalAmount: this.form.amount,
            loanPlanId: this.currentLoan.id,
            duration: this.form.duration,
          }
          this.form.active = true
          this.$axios
            .post('/loan/apply', data)
            .then(({ data }) => {
              console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('PaymentSuccessModal'),
                {}
              )
              modal.show()
              this.openNotification('top-left', 'success', data.message)
            })
            .catch((error) => {
              // console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    trimText(text) {
      return text.replace(/\s+/g, '-').toLowerCase()
    },
    fetchDurations() {
      const loading = this.$vs.loading({
        target: this.$refs.loanContent,
        color: 'primary',
        scale: 2,
      })
      this.$axios
        .$get(`/loan/plan/durations/${this.currentLoan.id}`)
        .then((response) => {
          loading.close()
          this.durations = response.payload.durationOptions
          // this. = response.payload.data
          // console.log(response)
        })
        .catch(() => {
          loading.close()
        })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-loans-page {
  .loan-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  input.form-control,
  .form-select,
  textarea.form-control {
    background-color: #f4f2ec;
    border-radius: 5px;
    border: none;
  }

  .loan-type-card {
    min-height: 100px;
    width: 100%;
    background-color: #fff;
    background-image: url(~@/assets/icons/image-26.svg);
    border-radius: 20px;
    padding: 16px 20px;
    background-repeat: no-repeat;
    background-position: right top;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    margin-bottom: 20px;
  }
  input.account-radio:checked + label {
    .loan-type-card {
      // background-color: red;
      background-position: 98% 94%, right top;
      background-image: url(~@/assets/images/tick.png),
        url(~@/assets/icons/image-26.svg);
    }
  }
}
</style>
